#!/usr/bin/env node
"use strict";function _interopDefault(e){return e&&"object"==typeof e&&"default"in e?e.default:e}function changes(){return transmute__default({}).extend("rawTags",gatherTags).extend("tags",parseTags).extend("latest",latestReleaseTag).extend("from",({latest:e})=>e.tag).extend("changes",gatherChanges)}function list(){return transmute.transmute({}).extend("root",findRepoRoot).extend("baseConfig",findBaseConfig).extend("exclude",["**/fixtures/**"]).extend("packages",findPackages)}function dependencies(...e){return list(...e).extend("dependencies",getDependencies)}function check(...e){return list(...e).extend("checks",publishCheck)}function publish(...e){return check(...e).extend("publishable",({packages:e,checks:t})=>e.filter(e=>t.packages[e.name].publishable)).extend("destination",destinationDetails)}function build(...e){return publish(...e).extend("configs",e=>buildRollupConfigs(_extends({},e,{packages:e.publishable})))}function version(...e){return publish(...e).extend(changes(...e).then(transmute.isolate(["changes","latest"]))).extend("dependencies",dependencies(...e).then(transmute.isolate("dependencies"))).extend("updates",recommendVersions)}function prerelease(...e){return check(...e).extend("unpublishable",({packages:e,checks:t})=>e.filter(e=>!t.packages[e.name].publishable)).extend("package",({unpublishable:e})=>pickPackage({message:"Which package should we prerelease?",packages:e})).extend("fixable",({package:{name:e},checks:t})=>Object.entries(t.packages[e]).filter(([e])=>solvable.includes(e)).filter(([,e])=>!e).map(([e])=>e)).extend("fixes",({package:e,fixable:t})=>Promise.all(t.map(t=>fixers[t](e).then(e=>({[t]:e})))).then(e=>e.reduce(collapse,{})))}var chalk=require("chalk"),parse=_interopDefault(require("minimist")),prettyJson=_interopDefault(require("jsome")),RenderKid=_interopDefault(require("renderkid")),transmute=require("transmutation"),transmute__default=_interopDefault(transmute),TS=_interopDefault(require("trie-search"));require("loud-rejection/register");var configureGit=_interopDefault(require("simple-git/promise")),fs=_interopDefault(require("fs")),unglob=_interopDefault(require("glob")),match=_interopDefault(require("minimatch")),pick=_interopDefault(require("lodash.pick")),promisify=_interopDefault(require("es6-promisify")),path=require("path"),fileExists=require("file-exists"),findUp=_interopDefault(require("find-up")),uniq=_interopDefault(require("lodash.uniq")),detective=_interopDefault(require("detective-es6")),rimraf=_interopDefault(require("rimraf")),rollup=require("rollup"),jsonFile=_interopDefault(require("jsonfile")),execa=_interopDefault(require("execa")),registryUrl=_interopDefault(require("registry-url")),localOrHomeNpmrc=_interopDefault(require("local-or-home-npmrc")),has=_interopDefault(require("lodash.has")),every=_interopDefault(require("lodash.every")),partial=_interopDefault(require("lodash.partial")),uglifyEs=require("uglify-es"),builtins=_interopDefault(require("builtin-modules")),babel=_interopDefault(require("rollup-plugin-babel")),uglify=_interopDefault(require("rollup-plugin-uglify")),filesize=_interopDefault(require("rollup-plugin-filesize")),executable=_interopDefault(require("rollup-plugin-executable")),resolve$1=_interopDefault(require("rollup-plugin-node-resolve")),map=_interopDefault(require("lodash.map")),filter=_interopDefault(require("lodash.filter")),intersect=_interopDefault(require("lodash.intersection")),semver=require("semver"),editor=_interopDefault(require("external-editor")),fuzzy=require("fuzzy"),find=_interopDefault(require("lodash.find")),inquirer=_interopDefault(require("inquirer")),autocomplete=_interopDefault(require("inquirer-autocomplete-prompt")),asyncToGenerator=function(e){return function(){var t=e.apply(this,arguments);return new Promise(function(e,n){function r(a,i){try{var s=t[a](i),o=s.value}catch(e){return void n(e)}if(!s.done)return Promise.resolve(o).then(function(e){r("next",e)},function(e){r("throw",e)});e(o)}return r("next")})}},_extends=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var r in n)Object.prototype.hasOwnProperty.call(n,r)&&(e[r]=n[r])}return e},toArray=function(e){return Array.isArray(e)?e:Array.from(e)},createSearcher=({commands:e=[]}={})=>{const t=e.map(e=>{const t=Array.isArray(e.aliases)?e.aliases:[e.aliases];return _extends({},e,{tokens:[e.name,...t].join(" ")})}),n=new TS(["tokens"]);return n.addAll(t),n};const jsonRender=e=>t=>prettyJson(transmute.isolate(e)(t)),configureKli=({defaultStyle:e,defaultRenderer:t=console.log}={})=>({commands:n=[]}={})=>{if(!Array.isArray(n))throw new Error("Commands must be an array");if(0===n.length)throw new Error("No commands defined");n.forEach(e=>{if("function"!=typeof e.run)throw new Error("All commands must have a run method")});const r=createSearcher({commands:n});return{execute:(a=[""])=>{var i=parse(a,{boolean:!0});const s=i._,o=i.commit,l=i.json,c=r.get(s[0]),u=0===c.length&&1===n.length?n[0]:c[0];if(!u)return console.log(chalk.red(`No command associated with \`${s[0]}\``));const p=Promise.resolve(u.run());if(l)return p.then(jsonRender(!0===l||l.split(",")));const m=u.renderer||t,d=new RenderKid;return d.style(e),p.then(e=>{m(u.template?d.render(u.template(e)):e),u.effect&&o&&u.effect(e)})}}},configure=configureKli,kli$1=configureKli({defaultRenderer:console.log});configureKli({defaultRenderer:console.log});var style={title:{display:"block",color:"bright-white",marginLeft:2,marginBottom:1},check:{display:"block",marginLeft:4},success:{display:"block",color:"grey",bullet:`"${chalk.green("✔")} "`},fail:{display:"block",color:"red",bullet:`"${chalk.red("✖")} "`},list:{display:"block",marginTop:1},item:{display:"block",marginBottom:1},change:{display:"block"},type:{color:"white"},scope:{color:"bright-white"},subject:{color:"grey"},attr:{display:"block",marginLeft:2},key:{color:"grey",marginRight:1},value:{color:"white"},bar:{display:"block",color:"green",bullet:`"${chalk.green("────────────────────────────────────────────────────────────────────────────────")}"`},h1:{display:"block",color:"bright-white",marginLeft:2}};const regex=/#(\d*)/;var parseTags=({rawTags:e=[]}={})=>e.map(e=>e.match(regex)||[]).filter(e=>e.length).map(([e,t])=>({tag:e,releaseNumber:parseInt(t,10)}));const git=configureGit();var gatherTags=()=>git.tags().then(({all:e})=>e),template=({changes:e})=>`\n    <bar>-</bar>\n    <h1>Changes</h1>\n    <bar>-</bar>\n    <list>\n        ${e.sort(()=>1).map(({type:e,scopes:t,subject:n})=>`\n                    <change>\n                        <type>${e}</type>\n                        <scope>(${t.join(",")})<scope>: \n                        <subject>${n}</subject>\n                    </change>\n                `).join("")}\n    </list>\n`;const regex$1=/^([^A-Z]*)\(((?:[^A-Z*]*)|\*)\): ([^a-z].*\.)$/,toHeaderOrBody=({body:e,matches:[,t,n,r]})=>t?{type:t,scopes:n.split(",").map(e=>e.trim()),subject:r}:{body:e},intoSingleCommits=(e,t)=>{if(0===e.length)return[t];var n=e.reverse(),r=toArray(n);const a=r[0],i=r.slice(1);return"body"in a&&"body"in t?[...i,_extends({},a,{body:[a.body,t.body].join("\n")})]:t.type?[...e,t]:[...i,_extends({},a,t)]},trimmedBodies=e=>e.body?_extends({},e,{body:e.body.trim()}):e;var parse$1=({commits:e=[]}={})=>Array.prototype.concat(...e.map(({hash:e,message:t,files:n})=>t.split(/\r?\n/).map(e=>({body:e,matches:e.match(regex$1)||[]})).map(toHeaderOrBody).reduce(intoSingleCommits,[]).map(trimmedBodies).map(t=>_extends({hash:e,files:n},t))));const git$1=configureGit();var gatherChanges=({from:e,to:t="HEAD"}={})=>git$1.log({from:e,to:t,format:{hash:"%H",message:"%B"}}).then(({all:e})=>Promise.all(e.map(e=>git$1.show(["--pretty=","--name-only",e.hash]).then(e=>e.trim().split("\n")).then(t=>_extends({},e,{files:t}))))).then(e=>({commits:e})).then(parse$1),latestReleaseTag=({tags:e=[]}={})=>e.filter(e=>e.releaseNumber).reduce((e,t)=>e.releaseNumber>t.releaseNumber?e:t,{tag:"HEAD",releaseNumber:0});const command={name:"changes",aliases:["changelog"],run:changes,template:template},glob=promisify(unglob),lstat=promisify(fs.lstat),have=e=>t=>match(e,t);var findPackages=({root:e=".",exclude:t=[]}={})=>new Promise((()=>{var n=asyncToGenerator(function*(n,r){try{const a=path.resolve(e,"src/node_modules");if(!(yield lstat(a)).isDirectory)return r("The `src/node_modules` directory does not exist!");const i=path.resolve(a,"{[^@]*/,@*/*/}");return n((yield glob(i)).filter(function(e){return!t.some(have(e))}).map(function(t){return path.relative(path.resolve(e,"src/node_modules"),t)}).map(function(t){return{name:t,dir:path.relative(e,path.resolve(e,"src/node_modules",t)),distDir:path.relative(e,path.resolve(e,"dist",t))}}).map(function(t){const n=path.resolve(e,t.dir,"package.json");if(fileExists.sync(n,{root:e}))return t;try{const e=require(n),r=pick(e,["version","bin","main"]);return _extends({},t,r,{config:e})}catch(e){return t}}))}catch(e){return r(e)}});return function(e,t){return n.apply(this,arguments)}})()),findRepoRoot=({anchor:e=".git"}={})=>findUp(e).then(path.dirname),template$1=({packages:e})=>`\n    <bar>-</bar>\n    <h1>Package List</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <attr><key>Name:</key><value>${e.name}</value></attr>\n                <attr><key>Version:</key><value>${e.version||"No version"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `,findBaseConfig=({root:e="."}={})=>require(path.resolve(e,"package.json"));const command$2={name:"list",aliases:["ls"],run:list,template:template$1};var template$2=({packages:e,dependencies:t})=>`\n    <bar>-</bar>\n    <h1>Package Dependencies</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(e=>`<item>\n                <title>${e.name}</title>\n                <attr><key>Local:</key><value>${t[e.name].filter(e=>e in t).join(", ")||"--- None ---"}</value></attr>\n                <attr><key>External:</key><value>${t[e.name].filter(e=>!(e in t)).join(", ")||"--- None ---"}</value></attr>\n            </item>`).join("")}\n    </list>\n    `,collapse=(e,t)=>{if(t.undefined){const n=e.undefined?[...e.undefined,t.undefined]:[t.undefined];return _extends({},e,{undefined:n})}return Object.assign(e,t)};const lstat$1=promisify(fs.lstat),readFile=promisify(fs.readFile),cache={};var detective$1=e=>(()=>{function t(e){return n.apply(this,arguments)}var n=asyncToGenerator(function*(n){if(!n)return{};const r=path.resolve(e,n);let a;try{const e=require(path.resolve(r,"package.json"));a=e.main?e.main:e.bin?Object.values(e.bin)[0]:"index.js"}catch(e){a="index.js"}return readFile(path.resolve(r,a),"utf-8").then(detective).then(function(n){return Promise.all(n.map((()=>{var n=asyncToGenerator(function*(n){try{if(n in cache)return cache[n];const r=path.resolve(e,n);return yield lstat$1(r),t(n).then(function(e){return 0===Object.keys(e).length&&e.constructor===Object?{[n]:!1}:{[n]:e}}).then(function(e){return cache[n]=e,e})}catch(e){return{[n]:!1}}});return function(e){return n.apply(this,arguments)}})())).then(function(e){return e.reduce(collapse,{})})})});return t})(),getDependencies=({root:e,packages:t=[]}={})=>{if(!e)return{};if(t.length<=0)return{};const n=path.resolve(e,"src","node_modules"),r=detective$1(n);return Promise.all(t.filter(({name:e})=>e).map(({name:e})=>r(e).then(e=>Object.entries(e).reduce(function e(t,[n,r]){return[...t,n,...Object.entries(r).reduce(e,[])]},[])).then(uniq).then(t=>({[e]:t})))).then(e=>e.reduce(collapse,{}))};const command$1={name:"dependencies",aliases:["deps","dependents"],run:dependencies,template:template$2},copy=promisify(fs.copyFile),writeJson=promisify(jsonFile.writeFile),requiredProps=["description","homepage","author","repository","bugs","license","dependencies"];var postBuild=({root:e,baseConfig:t,config:n})=>()=>Promise.all([copy(path.resolve(e,"LICENSE"),path.resolve(e,n.destDir,"LICENSE")),copy(path.resolve(e,n.srcDir,"readme.md"),path.resolve(e,n.destDir,"readme.md")),writeJson(path.resolve(e,n.destDir,"package.json"),_extends({name:n.name},n.packageConfig,pick(t,requiredProps)),{spaces:4})]);const removeDir=promisify(rimraf);var buildPackages=({root:e,baseConfig:t,configs:n=[]}={})=>removeDir(path.resolve(e,"dist")).then(()=>Promise.all(n.map(n=>rollup.rollup({input:path.resolve(e,n.input),external:n.external,plugins:n.plugins}).then(t=>Promise.all(n.output.map(r=>t.write({file:path.resolve(e,r.file),format:r.format,banner:n.banner})))).then(postBuild({root:e,baseConfig:t,config:n})))));const registry=registryUrl(),setAuthToken=e=>new Promise((t,n)=>{process.chdir(e);const r=localOrHomeNpmrc();console.log(".npmrc: ",r),fs.existsSync(r)||n("For some reason no npmrc file exists.");const a=`${registry.replace("https:","").replace("http:","")}:_authToken=`;console.log("test: ",a);const i=a+"${NPM_TOKEN}";console.log("token: ",i);const s=fs.readFileSync(r,"utf-8").trim()+"\n";if(console.log("contents: ",s),-1!==s.indexOf(i))return console.log("Just checked... .npmrc already has the token."),t();if(-1!==s.indexOf(a))return console.error("The .npmrc already has a token for this registry."),console.error(a),n(`Auth token for registry exists ${a}`);fs.writeFileSync(r,`${s}${i}\n`,"utf-8");const o=fs.readFileSync(r,"utf-8").trim()+"\n";return console.log("newContents: ",o),t()});var deployNpm=({root:e,publishable:t})=>setAuthToken(e).then(()=>Promise.all(t.map(({name:t})=>(process.chdir(path.resolve(e,"dist",t)),console.log(`Publishing [${t}]...`),execa("npm",["publish","--registry",registry]).then(e=>console.log(e.stdout)).catch(console.log)))));const lstat$3=promisify(fs.lstat);var checkPackage=(()=>{var e=asyncToGenerator(function*(e={},t="."){const n={};try{const r=path.resolve(t,e.dir,"readme.md"),a=yield lstat$3(r);n["has readme file"]=!!a.isFile}catch(e){n["has readme file"]=!1}try{if(e.main||!e.bin){const r=path.resolve(t,e.dir,e.main||"index.js"),a=yield lstat$3(r);n["has main and/or all bin files"]=!!a.isFile}if(e.bin){const r=Object.values(e.bin),a=yield Promise.all(r.map(function(n){return path.resolve(t,e.dir,n)}).map((()=>{var e=asyncToGenerator(function*(e){return lstat$3(e)});return function(t){return e.apply(this,arguments)}})()));n["has main and/or all bin files"]=!a.some(function(e){return!e.isFile})}}catch(e){n["has main and/or all bin files"]=!1}n["has a version number"]=!!e.version;return Object.values(n).some(function(e){return!e})?{[e.name]:_extends({},n,{publishable:!1})}:{[e.name]:_extends({},n,{publishable:!0})}});return function(){return e.apply(this,arguments)}})();const lstat$2=promisify(fs.lstat);var publishCheck=({root:e,baseConfig:t={},packages:n=[]}={})=>new Promise((()=>{var r=asyncToGenerator(function*(r){if(0===n.length)return r([]);const a=yield Promise.all(n.map(function(t){return checkPackage(t,e)})),i={};try{const t=path.resolve(e,"LICENSE"),n=yield lstat$2(t);i["has root license"]=!!n.isFile}catch(e){i["has root license"]=!1}return i["has required package.json fields"]=every(["description","homepage","author","repository","bugs","license","dependencies"],function(e){return partial(has,e)}(t)),r({root:i,packages:a.reduce(collapse,{})})});return function(e){return r.apply(this,arguments)}})()),template$3=({checks:e})=>`\n    <bar>-</bar>\n    <h1>Checked Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e.packages).map(([e,t])=>`<item>\n                <title>${e}</title>\n                ${Object.entries(t).filter(([e])=>"publishable"!==e).map(([e,t])=>t?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n                <check>${Array(Object.keys(t).reduce((e,t)=>e.length>t.length?e:t,0).length+3).join("─")}</check>\n                <check>${t.publishable?"<success>publishable</success>":"<fail>not publishable</fail>"}</check>\n            </item>`).join("")}\n    </list>\n    <bar>-</bar>\n    <title>Repository</title>\n    ${Object.entries(e.root).map(([e,t])=>t?`<check><success>${e}</success></check>`:`<check><fail>${e}</fail></check>`).join("")}\n    `;const command$5={name:"check",run:check,template:template$3},fields=["version"];var destinationDetails=({root:e,publishable:t})=>Promise.all(t.map(({name:t,distDir:n})=>Promise.all([execa("npm",["view",t,...fields]).then(e=>e.stdout).catch(()=>null),new Promise(t=>{try{return t(require(path.resolve(e,n,"package.json")).version)}catch(e){throw e}}).catch(()=>null)]).then(([e,n])=>({[t]:{destVersion:e,srcVersion:n}})))).then(e=>e.reduce(collapse,{})),template$4=({publishable:e,destination:t})=>`\n    <bar>-</bar>\n    <h1>Publishable Packages</h1>\n    <bar>-</bar>\n    <list>\n        ${e.map(({name:e})=>`<item>\n                    <check>\n                        <success>${e}</success>\n                        <attr><key>NPM:</key><value>${t[e].destVersion}</value></attr>\n                        <attr><key>Next:</key><value>${t[e].srcVersion}</value></attr>\n                    </check>\n                </item>`).join("")}\n    </list>\n`;const command$4={name:"publish",aliases:["deploy"],run:publish,template:template$4,effect:(...e)=>{var t=process.env;const n=t.NPM_TOKEN,r=t.GH_USER,a=t.GH_EMAIL,i=t.GH_REPO,s=t.GH_TOKEN;if(!n)throw new Error("The NPM_TOKEN env variable must be set!");if(!r)throw new Error("The GH_USER env variable must be set!");if(!a)throw new Error("The GH_EMAIL env variable must be set!");if(!i)throw new Error("The GH_REPO env variable must be set!");if(!s)throw new Error("The GH_TOKEN env variable must be set!");return deployNpm(...e)}},babelConfig={babelrc:!1,presets:[["env",{modules:!1,targets:{node:"6"}}],"stage-0"],plugins:["external-helpers"],exclude:["node_modules/**"]},basePackageInfo=e=>({name:e.name,srcDir:`./src/node_modules/${e.name}`,destDir:`./dist/${e.name}`,packageConfig:e.config,input:`./src/node_modules/${e.name}/${e.file}`}),plugins=[resolve$1({customResolveOptions:{moduleDirectory:"src/node_modules"}}),babel(babelConfig),uglify({},uglifyEs.minify),filesize()],binConfigs=({packages:e,baseConfig:t})=>e.filter(e=>e.bin).filter(e=>e.bin.constructor===Object).map(e=>Object.values(e.bin).map(n=>_extends({},basePackageInfo(_extends({},e,{file:n})),{external:[...builtins,...Object.keys(t.dependencies)],output:[{file:`./dist/${e.name}/${n}`,format:"cjs"}],banner:"#!/usr/bin/env node",plugins:[...plugins,executable()]}))),mainConfigs=({packages:e,baseConfig:t})=>e.filter(e=>!e.bin).map(e=>_extends({},e,{file:e.main||"index.js"})).map(e=>_extends({},basePackageInfo(e),{external:[...builtins,...Object.keys(t.dependencies)],output:[{file:`./dist/${e.name}/${e.file}`,format:"cjs"}],plugins:plugins}));var buildRollupConfigs=({packages:e=[],baseConfig:t={dependencies:{}}}={})=>new Promise(n=>n([].concat(...binConfigs({packages:e,baseConfig:t}),...mainConfigs({packages:e,baseConfig:t}))));const command$3={name:"build",renderer:()=>{},run:build,effect:buildPackages};var git$2=configureGit().outputHandler((e,t,n)=>{t.pipe(process.stdout),n.pipe(process.stderr)}),setupGit=()=>{var e=process.env;const t=e.GH_USER,n=e.GH_EMAIL,r=e.GH_REPO,a=e.GH_TOKEN;return console.log("Setting committer..."),git$2.addConfig("user.name",t).then(()=>git$2.addConfig("user.email",n)).then(()=>console.log("Setting up branch...")).then(()=>git$2.addRemote("origin-deploy",`https://${a}@github.com/${r}.git`)).then(()=>git$2.fetch("origin-deploy","master")).then(()=>git$2.checkout(["-B","deploy-master","--track","origin-deploy/master"])).then(()=>git$2.reset(["--hard","origin-deploy/master"]))},deployGit=()=>(console.log("Pushing to deploy remote..."),git$2.push(["origin-deploy","HEAD:master","--tags"]));const readJson=promisify(jsonFile.readFile),writeJson$1=promisify(jsonFile.writeFile),git$3=configureGit();var updatePackages=({root:e,updates:t,publishable:n,latest:r})=>{const a=r.releaseNumber+1;return console.log(`Starting release #${a}`),console.log("Updating package.json files..."),Promise.all(n.filter(e=>e.name in t).map(({name:n,dir:r})=>{const a=path.resolve(e,r,"package.json");return readJson(a).then(e=>_extends({},e,{version:t[n].new})).then(e=>writeJson$1(a,e,{spaces:4})).then(()=>({name:n,version:t[n].new,file:a}))})).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Staging files for commit..."),yield git$3.add(map(e,"file")),e});return function(t){return e.apply(this,arguments)}})()).then((()=>{var e=asyncToGenerator(function*(e){return console.log("Committing updates..."),yield git$3.commit(`release(${a}): Update package versions for ${e.length>1?`${e.length} packages.`:"1 package."}\n        \n${e.map(function({name:e,version:t}){return`v${t} ${e}`}).join("\n")}\n\n[skip ci]\n`),e});return function(t){return e.apply(this,arguments)}})()).then(e=>(console.log("Tagging commit with package versions..."),Promise.all(e.map(({name:e,version:t})=>git$3.addTag(`${e}-v${t}`))))).then(()=>(console.log("Tagging commit with new latest release tag..."),git$3.addTag(`#${a}`)))},template$5=({updates:e})=>`\n    <bar>-</bar>\n    <h1>Packages to be updated</h1>\n    <bar>-</bar>\n    <list>\n        ${Object.entries(e).map(([e,{old:t,new:n,type:r,reason:a}])=>`\n                    <item>\n                        <title>${e} - ${r}</title>\n                        <check>${a}</check>\n                        <check>${t} -> ${n}</check>\n                    </item>\n                `).join("")}\n    </list>\n    `;const createPatch=(e,t)=>({[e.name]:{type:"patch",old:e.version,new:semver.inc(e.version,"patch"),reason:t}});var recommendVersions=({publishable:e=[],packages:t=[],dependencies:n=[],changes:r=[]}={})=>!e||e.length<=0?{}:e.filter(e=>e.name).map(e=>{if(e.version){if("0.0.0"===e.version)return{[e.name]:{type:"patch",old:e.version,new:"0.0.1",reason:"Prereleased"}};if(semver.lt(e.version,"0.1.0")){const t=filter(r,t=>!!t.scopes&&t.scopes.includes(e.name));if(t.length>0)return createPatch(e,`This had ${1===t.length?"1 change":`${t.length} changes`} while in development.`);if(!n[e.name])return;const a=filter(r,t=>!!t.scopes&&intersect(n[e.name],t.scopes).length>0);if(a.length>0)return createPatch(e,`There ${1===a.length?"was 1 change":`were ${a.length} changes`} in dependencies while in development.`)}else;}}).filter(e=>e).reduce(collapse,{});const CI$1=process.env.CI,command$6={name:"version",aliases:["update"],run:version,template:template$5,effect:(...e)=>{if(!CI$1)throw new Error("Committing new versions should only happen in CI.");return setupGit().then(()=>updatePackages(...e)).then(()=>deployGit())}},wait=e=>new Promise(t=>setTimeout(t,e));var getContents=({message:e="Create some contents: ",contents:t="",pause:n=2e3}={})=>(console.log(`${chalk.green("?")} ${chalk.white.bold(`${e}: `)} ${chalk.grey(`Opening your editor in ${n/1e3} secs...`)}`),wait(n).then(()=>({contents:editor.edit(t)})));const writeFile=promisify(fs.writeFile),writeJson$2=promisify(jsonFile.writeFile),fixers$1={"has readme file":({root:e,pkg:t,contents:n})=>(console.log("Creating [readme.md]..."),writeFile(path.resolve(e,t.dir,"readme.md"),n))};var effect=({root:e,package:t,fixes:n})=>(console.log("Creating [package.json]..."),Promise.all([...Object.entries(n).map(([n,r])=>fixers$1[n](_extends({root:e,pkg:t},r))),writeJson$2(path.resolve(e,t.dir,"package.json"),{version:"0.0.0"},{spaces:4})])),template$6=({package:{name:e},fixes:t})=>`\n    <bar>-</bar>\n    <h1>Prereleasing [${e}]</h1>\n    <bar>-</bar>\n    <list>\n    ${Object.entries(t).map(([e])=>"has readme file"===e?"\n                <check><success>A readme will be created.</success></check>\n            ":"")}\n        <check><success>A version will be added.</success></check>\n    </list>\n`;inquirer.registerPrompt("autocomplete",autocomplete);const searchPackages=e=>(t,n="")=>new Promise(t=>{setTimeout(()=>t(fuzzy.filter(n,e,{extract:e=>e.name}).map(e=>e.original||e)),500)});var pickPackage=({message:e="Which package should we pick?",packages:t})=>inquirer.prompt([{type:"autocomplete",name:"name",message:e,source:searchPackages(t)}]).then(({name:e})=>find(t,{name:e}));const solvable=["has readme file"],fixers={"has readme file":e=>getContents({message:`Write your readme.md for ${e.name}`,contents:`# ${e.name}`})},command$7={name:"prerelease",run:prerelease,template:template$6,effect:effect},CI=process.env.CI,kli=configure({defaultStyle:CI?{}:style}),cli=kli({commands:[command$3,command,command$5,command$1,command$2,command$7,command$4,command$6]});cli.execute(process.argv.slice(2));
